#version 330 core

layout (location = 0) in vec3 position;
layout (location = 1) in vec3 normal;
layout (location = 2) in vec2 texCoords;

uniform mat4 viewProjection;
uniform mat4 model;
uniform float time;

out vec3 FragPos;
out vec3 Normal;
out vec2 TexCoords;

vec3 transformPosition(vec3 pos) {
	float sinArgument = time + pos.y * 5;
	float scale = 1.0 + 0.1 * sin(sinArgument * 2);
	return pos * scale;
}

void main() {
	FragPos = vec3(model * vec4(transformPosition(position), 1.0));
	Normal = vec3(model * vec4(normal, 0.0));
	TexCoords = texCoords;

	gl_Position = viewProjection * vec4(FragPos, 1.0);
}