#version 330

layout (points) in;
layout (triangle_strip) out;
layout (max_vertices = 4) out;

uniform mat4 viewProjection;
uniform vec3 cameraPosition;
uniform vec3 cameraUp;

out vec2 TexCoords;

#define size 0.1

void main() {
	vec3 pos = gl_in[0].gl_Position.xyz;
	vec3 posToCamera = normalize(cameraPosition - pos);
	vec3 right = normalize(cross(posToCamera, cameraUp)) * size;
	vec3 up = normalize(cross(right, posToCamera)) * size;

	pos -= right;
	gl_Position = viewProjection * vec4(pos, 1);
	TexCoords = vec2(0, 0);
	EmitVertex();

	pos += up;
	gl_Position = viewProjection * vec4(pos, 1);
	TexCoords = vec2(0, 1);
	EmitVertex();

	pos -= up;
	pos += right;
	gl_Position = viewProjection * vec4(pos, 1);
	TexCoords = vec2(1, 0);
	EmitVertex();

	pos += up;
	gl_Position = viewProjection * vec4(pos, 1);
	TexCoords = vec2(1, 1);
	EmitVertex();

	EndPrimitive();
}